/*
 * defs.h
 *
 * rcsid = "/net/bcomp/src/master/nexus/defs.h,v 1.14 1995/11/13 22:51:38 tuecke Exp"
 */

#ifndef _NEXUS_INCLUDE_DEFS_H
#define _NEXUS_INCLUDE_DEFS_H

/*
 * A magic number used in debugging nexus buffers
 */
#ifdef NEXUS_DEBUG
#define NEXUS_BUFFER_MAGIC 12344321
#endif

/*
 * MAX_NEW_PROCESS_PARAMS
 *
 * Maximum length (in bytes) that the new_process_params string can be.
 */
#define MAX_NEW_PROCESS_PARAMS 1024

/*
 * NEXUS_MAX_COMMAND_LENGTH
 *
 * Maximum length of any command strings that are created.
 */
#define NEXUS_MAX_COMMAND_LENGTH 1024

/*
 * NEXUS_HANDLER_HASH_TABLE_SIZE
 *
 * The size of the hash table.  The hash value for handler names
 * is the sum of the ASCII values of the characters of the
 * name, modulo NEXUS_HANDLER_HASH_TABLE_SIZE.
 *
 * This should not be changed arbitrarily, since compilers need
 * to know this value in order to pre-compute hash values.
 */
#define NEXUS_HANDLER_HASH_TABLE_SIZE 1021


/*
 * For use with the secure server to notify it to change directories
 * before executing a program.
 */
#define NEXUS_CD_NOTIFIER "\0"

#ifndef NEXUS_DATABASE_PREFIX
#define NEXUS_DATABASE_PREFIX "resource_database"
#endif

#define NEXUS_DATABASE_PREFIX_SIZE (sizeof(NEXUS_DATABASE_PREFIX)-1)

#ifndef NEXUS_DATABASE_FILE
#define NEXUS_DATABASE_FILE ".resource_database"
#endif

#define NEXUS_LIBA_SIZE (2 * sizeof(unsigned long))


/*
 * NEXUS_INT_SIZE
 *
 * The size of an integer on this machine.
 * Derived from the NEXUS_CLASS_TYPE.
 */
#if NEXUS_CLASS_TYPE == NEXUS_CLASS_TYPE_CRAYC90
#define NEXUS_INT_SIZE 8
#else
#define NEXUS_INT_SIZE 4
#endif

#endif /* _NEXUS_INCLUDE_DEFS_H */
