#
# Makefile.base
#
# rcsid = "/net/bcomp/src/master/nexus/makefile.bas,v 1.97 1995/11/27 19:36:51 schwab Exp"
#

O_DIR=.

PORTS0_DIR=ports0

BASE_OBJS =	\
	$(O_DIR)/args.$(G_OFILE) \
	$(O_DIR)/context.$(G_OFILE) \
	$(O_DIR)/db_iface.$(G_OFILE) \
	$(O_DIR)/error.$(G_OFILE) \
	$(O_DIR)/fault.$(G_OFILE) \
	$(O_DIR)/handler.$(G_OFILE) \
	$(O_DIR)/init.$(G_OFILE) \
	$(O_DIR)/mac_func.$(G_OFILE) \
	$(O_DIR)/nx_ver.$(G_OFILE) \
	$(O_DIR)/pablo.$(G_OFILE) \
	$(O_DIR)/pr_iface.$(G_OFILE) \
	$(O_DIR)/pr_local.$(G_OFILE) \
	$(O_DIR)/process.$(G_OFILE) \
	$(O_DIR)/sanity.$(G_OFILE)  \
	$(O_DIR)/st_iface.$(G_OFILE) \
	$(O_DIR)/trace.$(G_OFILE)  \
	$(O_DIR)/util.$(G_OFILE) \
	$(O_DIR)/$(G_NEXUS_TH_MODULE).$(G_OFILE) \
	$(O_DIR)/$(G_NEXUS_MD_MODULE).$(G_OFILE) \
	$(O_DIR)/$(G_NEXUS_NL_MODULE).$(G_OFILE) \
	$(G_NEXUS_STARTUP_OBJS) \
	$(G_NEXUS_PROTO_OBJS) \
	$(G_NEXUS_DATABASE_OBJS)

STATIC_OBJS = \
	$(O_DIR)/initwrap.$(G_OFILE) \
	$(G_NEXUS_STATIC_OTHER_OBJS)

OBJS =  $(BASE_OBJS) \
	$(STATIC_OBJS) \
	$(G_NEXUS_OTHER_OBJS)

BASE_OBJS_LITE =	\
	$(O_DIR)/args.$(G_OFILE) \
	$(O_DIR)/context.$(G_OFILE) \
	$(O_DIR)/db_iface.$(G_OFILE) \
	$(O_DIR)/error.$(G_OFILE) \
	$(O_DIR)/fault.$(G_OFILE) \
	$(O_DIR)/handler.$(G_OFILE) \
	$(O_DIR)/init.$(G_OFILE) \
	$(O_DIR)/mac_func.$(G_OFILE) \
	$(O_DIR)/nx_ver.$(G_OFILE) \
	$(O_DIR)/pablo.$(G_OFILE) \
	$(O_DIR)/pr_iface.$(G_OFILE) \
	$(O_DIR)/pr_local.$(G_OFILE) \
	$(O_DIR)/process.$(G_OFILE) \
	$(O_DIR)/sanity.$(G_OFILE)  \
	$(O_DIR)/st_iface.$(G_OFILE) \
	$(O_DIR)/trace.$(G_OFILE)  \
	$(O_DIR)/util.$(G_OFILE) \
	$(O_DIR)/$(G_NEXUS_MD_MODULE).$(G_OFILE) \
	$(O_DIR)/$(G_NEXUS_NL_MODULE).$(G_OFILE) \
	$(G_NEXUS_STARTUP_OBJS_LITE) \
	$(G_NEXUS_PROTO_OBJS) \
	$(G_NEXUS_DATABASE_OBJS)

STATIC_OBJS_LITE = \
	$(O_DIR)/initwrap.$(G_OFILE) \
	$(G_NEXUS_STATIC_OTHER_OBJS_LITE)

OBJS_LITE = \
	$(BASE_OBJS_LITE) \
	$(STATIC_OBJS_LITE) \
	$(G_NEXUS_OTHER_OBJS_LITE)

NEXUS_CONFIG=nexus_config.h
NEXUSLITE_CONFIG=nexuslite_config.h

HDRS = \
	$(NEXUS_CONFIG) \
	$(SRC_PATH)/dbgstate.h \
	$(SRC_PATH)/defs.h \
	$(SRC_PATH)/funcs.h \
	$(SRC_PATH)/globals.h \
	$(SRC_PATH)/internal.h \
	$(SRC_PATH)/macros.h \
	$(SRC_PATH)/nexus.h \
	$(SRC_PATH)/nx_sanity.h \
	$(SRC_PATH)/nx_ver.h \
	$(SRC_PATH)/pablo.h \
	$(SRC_PATH)/$(G_NEXUS_TH_MODULE).h \
	$(SRC_PATH)/$(G_NEXUS_TH_MODULE)_i.h \
	$(SRC_PATH)/types.h

INSTALL_HDRS = \
	nexus_config.h \
	nexuslite_config.h \
	$(SRC_PATH)/nexus.h \
	$(SRC_PATH)/dbgstate.h \
	$(SRC_PATH)/nexuslite.h \
	$(SRC_PATH)/nx_sanity.h \
	$(SRC_PATH)/nx_ver.h \
	$(SRC_PATH)/$(G_NEXUS_TH_MODULE).h \
	$(PORTS0_DIR)/ports0_config.h \
	$(PORTS0_DIR)/ports0lite_config.h \
	$(SRC_PATH)/$(PORTS0_DIR)/ports0.h \
	$(SRC_PATH)/$(PORTS0_DIR)/ports0lite.h \
	$(SRC_PATH)/$(PORTS0_DIR)/$(G_PORTS0_TH_MODULE).h 

LIBBASE = libnexus
LIB = $(LIBBASE)$(FLAVOR_SUFFIX).$(G_LIBFILE)
LIBBASE_LITE = libnexuslite
LIB_LITE = $(LIBBASE_LITE)$(FLAVOR_SUFFIX).$(G_LIBFILE)

OPT_FLAVOR = opt
SAFE_FLAVOR = safe
DEBUG_FLAVOR = debug
PROFILE_FLAVOR = profile

OPT_SUFFIX = _$(OPT_FLAVOR)
SAFE_SUFFIX = _$(SAFE_FLAVOR)
DEBUG_SUFFIX = _$(DEBUG_FLAVOR)
PROFILE_SUFFIX = _$(PROFILE_FLAVOR)

#FLAVOR_SUFFIXES = $(DEBUG_SUFFIX)
#FLAVOR_SUFFIXES = $(OPT_SUFFIX) $(DEBUG_SUFFIX)
FLAVOR_SUFFIXES = $(OPT_SUFFIX) $(DEBUG_SUFFIX) \
			$(PROFILE_SUFFIX) $(SAFE_SUFFIX)

OPT_DIR = $(OPT_FLAVOR)
SAFE_DIR = $(SAFE_FLAVOR)
DEBUG_DIR = $(DEBUG_FLAVOR)
PROFILE_DIR = $(PROFILE_FLAVOR)

OPT_DIR_LITE = $(OPT_FLAVOR)_lite
SAFE_DIR_LITE = $(SAFE_FLAVOR)_lite
DEBUG_DIR_LITE = $(DEBUG_FLAVOR)_lite
PROFILE_DIR_LITE = $(PROFILE_FLAVOR)_lite

PORTS0_BUILD=build_objs
PORTS0_ECHO=echo_objs
PORTS0_LIB=
PORTS0LITE_LIB=
# Use the following if you want to link agaist libports0 instead
# of directly putting the ports0 object files into libnexus.
#PORTS0_BUILD=build
#PORTS0_ECHO=echo_dummy
#PORTS0_LIB=-L$(PORTS0_DIR) -lports0_debug
#PORTS0LITE_LIB=-L$(PORTS0_DIR) -lports0lite_debug

MY_CFLAGS= $(G_CFLAGS) -I. -I$(SRC_PATH) -I$(INCLUDE_PATH) \
	-I$(PORTS0_DIR) -I$(SRC_PATH)/$(PORTS0_DIR) $(FLAVOR_CFLAGS)

MY_CFLAGS_LITE= $(G_CFLAGS_LITE) -I. -I$(SRC_PATH) -I$(INCLUDE_PATH) \
	-I$(PORTS0_DIR) -I$(SRC_PATH)/$(PORTS0_DIR) $(FLAVOR_CFLAGS)

MY_MAKEFLAGS = -f $(G_MAKEFILE)

default:	build build_lite sserver listener

build:		lib

build_lite:	lib_lite

force:

build_headers:	$(NEXUS_CONFIG)

clean:	force
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR); \
			$(G_RM) -f $(G_MAKEFILE); \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ; \
			$(G_MAKE) -f $(G_MAKEFILE) clean ; \
			$(G_RM) -f $(G_MAKEFILE) ) ; \
	else \
		(cd $(PORTS0_DIR); \
			$(G_MAKE) -f $(G_MAKEFILE) clean ) ; \
	fi
	- $(G_RM) -rf $(NEXUS_CONFIG) $(NEXUSLITE_CONFIG) \
		$(BASE_OBJS) $(STATIC_OBJS) $(LIBBASE)* \
		$(OPT_DIR) $(SAFE_DIR) $(DEBUG_DIR) $(PROFILE_DIR) \
		$(OPT_DIR_LITE) $(SAFE_DIR_LITE) \
		$(DEBUG_DIR_LITE) $(PROFILE_DIR_LITE) \
		pr_eui.c pr_inx.c pr_mpl.c pr_mpl1.c pr_mpl2.c \
		pr_atm.c pr_udp.c pr_mn_udp.c \
		test test.dl testo testp tests \
		testlite testliteo testlitep testlites \
		testo.c testp.c tests.c test*.o testlite*.o \
		testlite.c testliteo.c testlitep.c testlites.c \
		ppthread ppthread.o nexus.exp mputil.mp_* \
		ibm_entrypt ibm_entrypt.exp \
		iserver sserver listener.o server.o P4Server.Log.* \
		Secure_Server.Log.* listener listener.o \
		nexus_server nexus_server.o \
		nexus_server_helper nexus_server_helper.o \
		hash core a.out *.log *~ \#*

release_clean:	force
	- $(G_RM) -rf COPYRIGHT TEST configure.in config crypto docs \
		perf rdb todo ports0/docs

objs:		$(OBJS)

lib: force	
	for i in $(FLAVOR_SUFFIXES) ; \
	  do \
	    $(G_MAKE) $(MY_MAKEFLAGS) build$${i} ; \
	    if [ $$? -ne 0 ] ; then exit 1 ; fi \
	  done

lib_lite: force	
	for i in $(FLAVOR_SUFFIXES) ; \
	  do \
	    $(G_MAKE) $(MY_MAKEFLAGS) build$${i}_lite ; \
	    if [ $$? -ne 0 ] ; then exit 1 ; fi \
	  done


build_opt: $(NEXUS_CONFIG) force
	- if [ ! -d $(OPT_DIR) ] ; then $(G_MKDIR) $(OPT_DIR) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_opt ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_opt)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_opt.$(G_LIBFILE) \
		"O_DIR=$(OPT_DIR)" \
		"FLAVOR_SUFFIX=_opt" \
		"FLAVOR_CFLAGS=$(G_OPT_CFLAGS)" \
		"PORTS0_OBJS=$${p0_objs}"

build_safe: $(NEXUS_CONFIG) force
	- if [ ! -d $(SAFE_DIR) ] ; then $(G_MKDIR) $(SAFE_DIR) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_safe ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_safe)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_safe.$(G_LIBFILE) \
		"O_DIR=$(SAFE_DIR)" \
		"FLAVOR_SUFFIX=_safe" \
		"FLAVOR_CFLAGS=$(G_SAFE_CFLAGS)" \
		"PORTS0_OBJS=$${p0_objs}"

build_debug: $(NEXUS_CONFIG) force
	- if [ ! -d $(DEBUG_DIR) ] ; then $(G_MKDIR) $(DEBUG_DIR) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I../$(SRC_PATH) \
			$(PORTS0_BUILD)_debug ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_debug)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_debug.$(G_LIBFILE) \
		"O_DIR=$(DEBUG_DIR)" \
		"FLAVOR_SUFFIX=_debug" \
		"FLAVOR_CFLAGS=$(G_DEBUG_CFLAGS)" \
		"PORTS0_OBJS=$${p0_objs}"

build_profile: $(NEXUS_CONFIG) force
	- if [ ! -d $(PROFILE_DIR) ] ; then $(G_MKDIR) $(PROFILE_DIR) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_profile ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_profile)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) $(LIBBASE)_profile.$(G_LIBFILE) \
		"O_DIR=$(PROFILE_DIR)" \
		"FLAVOR_SUFFIX=_profile" \
		"FLAVOR_CFLAGS=$(G_PROFILE_CFLAGS)" \
		"PORTS0_OBJS=$${p0_objs}"


build_opt_lite: force
	- if [ ! -d $(OPT_DIR_LITE) ] ; then $(G_MKDIR) $(OPT_DIR_LITE) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_opt_lite ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_opt_lite)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) \
		$(NEXUSLITE_CONFIG) $(LIBBASE_LITE)_opt.$(G_LIBFILE) \
		"O_DIR=$(OPT_DIR_LITE)" \
		"FLAVOR_SUFFIX=_opt" \
		"FLAVOR_CFLAGS=$(G_OPT_CFLAGS_LITE)" \
		"PORTS0_OBJS=$${p0_objs}" \
		"NEXUS_CONFIG=$(NEXUSLITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DNEXUS_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"NEXUS_LITE=yes"

build_safe_lite: force
	- if [ ! -d $(SAFE_DIR_LITE) ] ; then $(G_MKDIR) $(SAFE_DIR_LITE) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_safe_lite ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_safe_lite)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) \
		$(NEXUSLITE_CONFIG) $(LIBBASE_LITE)_safe.$(G_LIBFILE) \
		"O_DIR=$(SAFE_DIR_LITE)" \
		"FLAVOR_SUFFIX=_safe" \
		"FLAVOR_CFLAGS=$(G_SAFE_CFLAGS_LITE)" \
		"PORTS0_OBJS=$${p0_objs}" \
		"NEXUS_CONFIG=$(NEXUSLITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DNEXUS_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"NEXUS_LITE=yes"

build_debug_lite: force
	- if [ ! -d $(DEBUG_DIR_LITE) ] ; then $(G_MKDIR) $(DEBUG_DIR_LITE) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I../$(SRC_PATH) \
			$(PORTS0_BUILD)_debug_lite ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_debug_lite)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) \
		$(NEXUSLITE_CONFIG) $(LIBBASE_LITE)_debug.$(G_LIBFILE) \
		"O_DIR=$(DEBUG_DIR_LITE)" \
		"FLAVOR_SUFFIX=_debug" \
		"FLAVOR_CFLAGS=$(G_DEBUG_CFLAGS_LITE)" \
		"PORTS0_OBJS=$${p0_objs}" \
		"NEXUS_CONFIG=$(NEXUSLITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DNEXUS_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"NEXUS_LITE=yes"

build_profile_lite: force
	- if [ ! -d $(PROFILE_DIR_LITE) ] ; then $(G_MKDIR) $(PROFILE_DIR_LITE) ; fi
	if [ "x$(G_NEXUS_SPOOF_P0_MAKEFILE)" = "xyes" ] ; then \
		(cd $(PORTS0_DIR) ; \
			$(G_RM) -f $(G_MAKEFILE) ; \
			$(G_SYMLINK) ../$(G_MAKEFILE) . ) ; \
	fi
	(cd $(PORTS0_DIR) ; \
		$(G_MAKE) -f $(G_MAKEFILE) OTHER_CFLAGS=-I$(SRC_PATH)/../. \
			$(PORTS0_BUILD)_profile_lite ) ; \
	p0_objs="`(cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) ECHO_OBJS_PREFIX=$(PORTS0_DIR)/ $(PORTS0_ECHO)_profile_lite)`" ; \
	$(G_MAKE) $(MY_MAKEFLAGS) \
		$(NEXUSLITE_CONFIG) $(LIBBASE_LITE)_profile.$(G_LIBFILE) \
		"O_DIR=$(PROFILE_DIR_LITE)" \
		"FLAVOR_SUFFIX=_profile" \
		"FLAVOR_CFLAGS=$(G_PROFILE_CFLAGS_LITE)" \
		"PORTS0_OBJS=$${p0_objs}" \
		"NEXUS_CONFIG=$(NEXUSLITE_CONFIG)" \
		"G_CC=$(G_CC_LITE)" \
		"G_CFLAGS=$(G_CFLAGS_LITE) -DNEXUS_LITE" \
		"G_CLIBS=$(G_CLIBS_LITE)" \
		"G_LDFLAGS=$(G_LDFLAGS_LITE)" \
		"NEXUS_LITE=yes"


echo_base_objs:	force
	@ echo "$(BASE_OBJS)"

echo_static_objs:	force
	@ echo "$(STATIC_OBJS)"

echo_base_objs_opt: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(OPT_DIR)" echo_base_objs
	@ (cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) \
		ECHO_OBJS_PREFIX=$(ECHO_OBJS_PREFIX)$(PORTS0_DIR)/ \
		$(PORTS0_ECHO)_opt)

echo_base_objs_safe: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(SAFE_DIR)" echo_base_objs
	@ (cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) \
		ECHO_OBJS_PREFIX=$(ECHO_OBJS_PREFIX)$(PORTS0_DIR)/ \
		$(PORTS0_ECHO)_safe)

echo_base_objs_debug: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(DEBUG_DIR)" echo_base_objs
	@ (cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) \
		ECHO_OBJS_PREFIX=$(ECHO_OBJS_PREFIX)$(PORTS0_DIR)/ \
		$(PORTS0_ECHO)_debug)

echo_base_objs_profile: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(PROFILE_DIR)" echo_base_objs
	@ (cd $(PORTS0_DIR); $(G_MAKE) -f $(G_MAKEFILE) \
		ECHO_OBJS_PREFIX=$(ECHO_OBJS_PREFIX)$(PORTS0_DIR)/ \
		$(PORTS0_ECHO)_profile)

echo_static_objs_opt: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(OPT_DIR)" echo_static_objs

echo_static_objs_safe: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(SAFE_DIR)" echo_static_objs

echo_static_objs_debug: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(DEBUG_DIR)" echo_static_objs

echo_static_objs_profile: force
	@ $(G_MAKE) $(MY_MAKEFLAGS) \
		"O_DIR=$(ECHO_OBJS_PREFIX)$(PROFILE_DIR)" echo_static_objs


install:	force
	- $(G_MKDIR) $(INSTALL_BASE_DIR)
	- $(G_MKDIR) $(INSTALL_BIN_DIR)
	- $(G_MKDIR) $(INSTALL_LIB_DIR)
	- $(G_MKDIR) $(INSTALL_INC_DIR)
	$(G_MAKE) $(MY_MAKEFLAGS) \
		install_libs install_headers install_ibm_entrypt \
		install_misc_exe install_misc_files install_sserver

install_sserver:
	if [ -x sserver ] ; then \
	    $(G_CP) sserver $(INSTALL_BIN_DIR)/sserver ; \
	    $(G_CHMOD) $(G_EXE_FILE_MODE) $(INSTALL_BIN_DIR)/sserver ; \
	fi
	if [ -x listener ] ; then \
	    $(G_CP) listener $(INSTALL_BIN_DIR)/listener ; \
	    $(G_CHMOD) $(G_EXE_FILE_MODE) $(INSTALL_BIN_DIR)/listener ; \
	fi

install_ibm_entrypt:
	if [ -x ibm_entrypt ] ; then \
	    $(G_CP) ibm_entrypt $(INSTALL_BIN_DIR)/ibm_entrypt ; \
	    $(G_CHMOD) $(G_EXE_FILE_MODE) $(INSTALL_BIN_DIR)/ibm_entrypt ; \
	fi
	if [ -f ibm_entrypt.exp ] ; then \
	    $(G_CP) ibm_entrypt.exp $(INSTALL_LIB_DIR)/ibm_entrypt.exp ; \
	    $(G_CHMOD) $(G_FILE_MODE) $(INSTALL_LIB_DIR)/ibm_entrypt.exp ; \
	fi

install_misc_exe:
	if [ -n "$(G_MISC_EXE)" ] ; then \
	  for i in "$(G_MISC_EXE)" ; \
	    do \
	      if [ -f "$$i" ] ; then \
	         file=$$i ; \
	      elif [ -f $(SRC_PATH)/$$i ] ; then \
	         file=$(SRC_PATH)/$$i ; \
	      fi; \
	      $(G_CP) $$file $(INSTALL_BIN_DIR)/$$i ; \
	      $(G_CHMOD) $(G_EXE_FILE_MODE) $(INSTALL_BIN_DIR)/$$i ; \
	    done ; \
	fi

install_misc_files:
	if [ -n "$(G_MISC_FILES)" ] ; then \
	  for i in "$(G_MISC_FILES)" ; \
	    do \
	      if [ -f "$$i" ] ; then \
	         file=$$i ; \
	      elif [ -f $(SRC_PATH)/$$i ] ; then \
	         file=$(SRC_PATH)/$$i ; \
	      fi; \
	      $(G_CP) $$file $(INSTALL_LIB_DIR)/$$i ; \
	      $(G_CHMOD) $(G_FILE_MODE) $(INSTALL_LIB_DIR)/$$i ; \
	    done ;  \
	fi

install_libs:
	for i in $(FLAVOR_SUFFIXES) ; \
	  do \
	    $(G_MAKE) $(MY_MAKEFLAGS) "INST_LIB=$(LIBBASE)$${i}.$(G_LIBFILE)" install_lib ; \
	    $(G_MAKE) $(MY_MAKEFLAGS) "INST_LIB=$(LIBBASE_LITE)$${i}.$(G_LIBFILE)" install_lib ; \
	    if [ $$? -ne 0 ] ; then exit 1 ; fi \
	  done

install_lib: force
	if [ -f $(INST_LIB) ] ; then \
	  $(G_CP) $(INST_LIB) $(INSTALL_LIB_DIR)/$(INST_LIB) ; \
	  $(G_CHMOD) $(G_FILE_MODE) $(INSTALL_LIB_DIR)/$(INST_LIB) ; \
	  $(G_RANLIB) $(INSTALL_LIB_DIR)/$(INST_LIB) ; \
	fi

install_headers: force
	for hdr in $(INSTALL_HDRS) ; do \
	  if [ -f $${hdr} ] ; then \
	    cp $${hdr} $(INSTALL_INC_DIR)/. ; \
	  fi \
	done


$(O_DIR)/args.$(G_OFILE):	$(SRC_PATH)/args.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/args.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./args.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/context.$(G_OFILE):	$(SRC_PATH)/context.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/context.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./context.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/db_file.$(G_OFILE):	$(SRC_PATH)/db_file.c $(HDRS) $(SRC_PATH)/db_file_parser.c
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/db_file.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./db_file.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/db_iface.$(G_OFILE):	$(SRC_PATH)/db_iface.c $(SRC_PATH)/db_file_parser.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/db_iface.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./db_iface.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/error.$(G_OFILE):	$(SRC_PATH)/error.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/error.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./error.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/fault.$(G_OFILE):	$(SRC_PATH)/fault.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/fault.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./fault.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/gmalloc.$(G_OFILE):	$(SRC_PATH)/gmalloc.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/gmalloc.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./gmalloc.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/handler.$(G_OFILE):	$(SRC_PATH)/handler.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/handler.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./handler.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/init.$(G_OFILE):	$(SRC_PATH)/init.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/init.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./init.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/initwrap.$(G_OFILE):	$(SRC_PATH)/initwrap.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/initwrap.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./initwrap.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/nx_ver.$(G_OFILE):	$(SRC_PATH)/nx_ver.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/nx_ver.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./nx_ver.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/mac_func.$(G_OFILE):	$(SRC_PATH)/mac_func.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/mac_func.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./mac_func.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pablo.$(G_OFILE):	$(SRC_PATH)/pablo.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pablo.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pablo.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_eui.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(SRC_PATH)/mp_eui.h \
				$(HDRS)
	$(G_RM) -f pr_eui.c
	$(G_SYMLINK) $(SRC_PATH)/pr_mp.c pr_eui.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_MP_INCLUDE=\"mp_eui.h\" \
		-c pr_eui.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_eui.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_inx.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(SRC_PATH)/mp_inx.h \
				$(HDRS)
	$(G_RM) -f pr_inx.c
	$(G_SYMLINK) $(SRC_PATH)/pr_mp.c pr_inx.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_MP_INCLUDE=\"mp_inx.h\" \
		-c pr_inx.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_inx.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_mpl.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(SRC_PATH)/mp_mpl.h \
				$(HDRS)
	$(G_RM) -f pr_mpl.c
	$(G_SYMLINK) $(SRC_PATH)/pr_mp.c pr_mpl.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_MP_INCLUDE=\"mp_mpl.h\" \
		-c pr_mpl.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_mpl.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_mpl1.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(SRC_PATH)/mp_mpl1.h \
				$(HDRS)
	$(G_RM) -f pr_mpl1.c
	$(G_SYMLINK) $(SRC_PATH)/pr_mp.c pr_mpl1.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_MP_INCLUDE=\"mp_mpl1.h\" \
		-c pr_mpl1.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_mpl1.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_mpl2.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(SRC_PATH)/mp_mpl2.h \
				$(HDRS)
	$(G_RM) -f pr_mpl2.c
	$(G_SYMLINK) $(SRC_PATH)/pr_mp.c pr_mpl2.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_MP_INCLUDE=\"mp_mpl2.h\" \
		-c pr_mpl2.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_mpl2.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_iface.$(G_OFILE):	$(SRC_PATH)/pr_iface.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pr_iface.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_iface.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_local.$(G_OFILE):	$(SRC_PATH)/pr_local.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pr_local.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_local.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_tcp.$(G_OFILE):	$(SRC_PATH)/pr_tcp.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pr_tcp.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_tcp.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_atm.$(G_OFILE):	$(SRC_PATH)/pr_rx.c $(SRC_PATH)/rx_atm.h \
				$(HDRS)
	$(G_RM) -f pr_atm.c
	$(G_SYMLINK) $(SRC_PATH)/pr_rx.c pr_atm.c
	$(G_CC) $(MY_CFLAGS) $(FORE_INC) -DNEXUS_RX_INCLUDE=\"rx_atm.h\" \
		-c pr_atm.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_atm.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_udp.$(G_OFILE):	$(SRC_PATH)/pr_rx.c $(SRC_PATH)/rx_udp.h \
				$(HDRS)
	$(G_RM) -f pr_udp.c
	$(G_SYMLINK) $(SRC_PATH)/pr_rx.c pr_udp.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_RX_INCLUDE=\"rx_udp.h\" \
		-c pr_udp.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_udp.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_mn_udp.$(G_OFILE):	$(SRC_PATH)/pr_rx.c $(SRC_PATH)/rx_mn_udp.h \
				$(HDRS)
	$(G_RM) -f pr_mn_udp.c
	$(G_SYMLINK) $(SRC_PATH)/pr_rx.c pr_mn_udp.c
	$(G_CC) $(MY_CFLAGS) -DNEXUS_RX_INCLUDE=\"rx_mn_udp.h\" \
		-c pr_mn_udp.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_mn_udp.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_pvm.$(G_OFILE):	$(SRC_PATH)/pr_pvm.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pr_pvm.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_pvm.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/pr_mp.$(G_OFILE):	$(SRC_PATH)/pr_mp.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/pr_mp.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./pr_mp.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/process.$(G_OFILE):	$(SRC_PATH)/process.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/process.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./process.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/sanity.$(G_OFILE):	$(SRC_PATH)/sanity.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/sanity.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./sanity.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_iface.$(G_OFILE):	$(SRC_PATH)/st_iface.c $(SRC_PATH)/db_file_parser.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_iface.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_iface.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_eui.$(G_OFILE):	$(SRC_PATH)/st_eui.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_eui.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_eui.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_fork.$(G_OFILE):	$(SRC_PATH)/st_fork.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_fork.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_fork.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_inx.$(G_OFILE):	$(SRC_PATH)/st_inx.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_inx.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_inx.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_mpl.$(G_OFILE):	$(SRC_PATH)/st_mpl.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_mpl.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_mpl.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_nexus_server.$(G_OFILE):	$(SRC_PATH)/crypto/st_nexus_server.c $(SRC_PATH)/crypto/st_nexus_server.h $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/crypto/st_nexus_server.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_nexus_server.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_pvm.$(G_OFILE):	$(SRC_PATH)/st_pvm.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_pvm.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_pvm.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_rsh.$(G_OFILE):	$(SRC_PATH)/st_rsh.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_rsh.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_rsh.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_ss.$(G_OFILE):	$(SRC_PATH)/st_ss.c $(HDRS) $(SRC_PATH)/ss_start.h
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_ss.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_ss.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_soldl.$(G_OFILE):	$(SRC_PATH)/st_soldl.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_soldl.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_soldl.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_ibmld.$(G_OFILE):	$(SRC_PATH)/st_ibmld.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_ibmld.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_ibmld.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/ibm_cpp_load.$(G_OFILE): $(SRC_PATH)/ibm_cpp_load.o
	- if [ $(O_DIR) != "." ] ; then \
		$(G_CP) -p $(SRC_PATH)/ibm_cpp_load.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_ibmds.$(G_OFILE):	$(SRC_PATH)/st_ibmds.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_ibmds.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_ibmds.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_ibmds2.$(G_OFILE):	$(SRC_PATH)/st_ibmds2.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_ibmds2.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_ibmds2.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/st_ibmds4.$(G_OFILE):	$(SRC_PATH)/st_ibmds4.s $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/st_ibmds4.s
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./st_ibmds4.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/trace.$(G_OFILE):	$(SRC_PATH)/trace.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/trace.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./trace.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/util.$(G_OFILE):	$(SRC_PATH)/util.c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/util.c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./util.$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/$(G_NEXUS_TH_MODULE).$(G_OFILE):	$(SRC_PATH)/$(G_NEXUS_TH_MODULE).c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/$(G_NEXUS_TH_MODULE).c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./$(G_NEXUS_TH_MODULE).$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/$(G_NEXUS_MD_MODULE).$(G_OFILE):	$(SRC_PATH)/$(G_NEXUS_MD_MODULE).c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/$(G_NEXUS_MD_MODULE).c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./$(G_NEXUS_MD_MODULE).$(G_OFILE) $(O_DIR)/. ; \
	fi

$(O_DIR)/$(G_NEXUS_NL_MODULE).$(G_OFILE):	$(SRC_PATH)/$(G_NEXUS_NL_MODULE).c $(HDRS)
	$(G_CC) $(MY_CFLAGS) -c $(SRC_PATH)/$(G_NEXUS_NL_MODULE).c
	- if [ $(O_DIR) != "." ] ; then \
		$(G_MV) ./$(G_NEXUS_NL_MODULE).$(G_OFILE) $(O_DIR)/. ; \
	fi


$(NEXUS_CONFIG):	$(G_MAKEFILE) makefile.bas
	-$(G_RM) -f $(NEXUS_CONFIG)
	@echo "Creating $(NEXUS_CONFIG)"
	echo "" > $(NEXUS_CONFIG) ; \
	echo "#ifndef _NEXUS_INCLUDE_NEXUS_CONFIG_H" >> $(NEXUS_CONFIG) ; \
	echo "#define _NEXUS_INCLUDE_NEXUS_CONFIG_H" >> $(NEXUS_CONFIG) ; \
	echo "" >> $(NEXUS_CONFIG) ; \
	if [ "x$(NEXUS_LITE)" = "xyes" ] ; then \
	    echo "#ifndef NEXUS_LITE" >> $(NEXUS_CONFIG) ; \
	    echo "#define NEXUS_LITE" >> $(NEXUS_CONFIG) ; \
	    echo "#endif" >> $(NEXUS_CONFIG) ; \
	    echo "" >> $(NEXUS_CONFIG) ; \
	fi ; \
	echo "#define NEXUS_ARCH_$(G_ARCH)" >> $(NEXUS_CONFIG) ; \
	if [ "x$(NEXUS_LITE)" = "xyes" ] ; then \
	    for i in $(G_OTHER_ARCH_LITE) DUMMY ; \
	      do \
	        echo "#define NEXUS_ARCH_$$i" >> $(NEXUS_CONFIG) ; \
	    done; \
	else \
	    for i in $(G_OTHER_ARCH) DUMMY ; \
	      do \
	        echo "#define NEXUS_ARCH_$$i" >> $(NEXUS_CONFIG) ; \
	    done; \
	fi ; \
	echo "#define NEXUS_ARCH_STRING \"$(G_ARCH)\"" >> $(NEXUS_CONFIG) ; \
	echo "#define NEXUS_ARCH_TYPE NEXUS_ARCH_TYPE_$(G_ARCH)" >> $(NEXUS_CONFIG) ; \
	echo "#define NEXUS_CLASS_TYPE NEXUS_CLASS_TYPE_$(G_CLASS)" >> $(NEXUS_CONFIG) ; \
	echo "" >> $(NEXUS_CONFIG) ; \
	echo "#define NEXUS_TH_HEADER \"$(G_NEXUS_TH_MODULE).h\"" >> $(NEXUS_CONFIG) ; \
	echo "#define NEXUS_THI_HEADER \"$(G_NEXUS_TH_MODULE)_i.h\"" >> $(NEXUS_CONFIG) ; \
	echo "" >> $(NEXUS_CONFIG) ; \
	echo "#define NEXUS_RSH \"$(G_RSH)\"" >> $(NEXUS_CONFIG) ; \
	if [ "x$(G_LISTENER)" != "x" ] ; then \
	  echo "#define NEXUS_LISTENER \"$(G_LISTENER)\"" >> $(NEXUS_CONFIG) ; \
	else \
	  echo "#define NEXUS_LISTENER \"listener\"" >> $(NEXUS_CONFIG) ; \
	fi ; \
	echo "" >> $(NEXUS_CONFIG) ; \
	for i in NEXUS_DUMMY_DEFINE1 $(G_NEXUS_CONFIG) NEXUS_DUMMY_DEFINE2 ; \
	  do \
	    out1=`echo $$i | sed s/=.*$$//` ; \
	    out2=`echo $$i | sed s/$${out1}=\*//` ; \
	    echo "#ifndef $$out1" >> $(NEXUS_CONFIG) ; \
	    echo "#define $$out1 $$out2" >> $(NEXUS_CONFIG) ; \
	    echo "#endif" >> $(NEXUS_CONFIG) ; \
	    echo "" >> $(NEXUS_CONFIG) ; \
	done; \
	echo "#endif /* _NEXUS_INCLUDE_NEXUS_CONFIG_H */" >> $(NEXUS_CONFIG) ; \
	echo "" >> $(NEXUS_CONFIG) 


include $(SRC_PATH)/makefile.lnk$(G_MAKEFILE_LNK_SUFFIX)


nexus.tar: force
	tar cf nexus.tar *.c *.h makefile.*

nexus.tar.Z: force
	tar cf - *.c *.h makefile.* | compress > nexus.tar.Z


listener:	$(SRC_PATH)/listener.c $(SRC_PATH)/ss_start.h $(NEXUS_CONFIG)
	$(G_RM) -f listener
	$(G_CC_LITE) $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o listener $(SRC_PATH)/listener.c

sserver:	$(SRC_PATH)/server.c
	$(G_RM) -f sserver
	$(G_CC_LITE) $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o sserver $(SRC_PATH)/server.c

server:		$(SRC_PATH)/server.c
	$(G_RM) -f server
	$(G_CC_LITE) $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o server $(SRC_PATH)/server.c

iserver:		$(SRC_PATH)/server.c
	$(G_RM) -f iserver
	$(G_CC_LITE) $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) -DIWAY \
		-o iserver $(SRC_PATH)/server.c


nexus_server: build_$(DEBUG_FLAVOR) nexus_server.$(G_OFILE) 
	$(G_RM) -f nexus_server
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) $(G_LDFLAGS) \
		-o nexus_server nexus_server.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(DEBUG_FLAVOR).$(G_LIBFILE) \
		$(PORTS0_LIB) $(G_CLIBS)

nexus_server.$(G_OFILE):	$(SRC_PATH)/crypto/nexus_server.c $(SRC_PATH)/crypto/st_nexus_server.h
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) \
	    -c $(SRC_PATH)/crypto/nexus_server.c 

nexus_server_helper: nexus_server_helper.$(G_OFILE)
	$(G_RM) -f nexus_server_helper
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) $(G_LDFLAGS) \
		-o nexus_server_helper nexus_server_helper.$(G_OFILE) 

nexus_server_helper.$(G_OFILE):	$(SRC_PATH)/crypto/nexus_server_helper.c
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) \
		-c $(SRC_PATH)/crypto/nexus_server_helper.c

	
test:	build_$(DEBUG_FLAVOR) test.$(G_OFILE)
	$(G_RM) -f test
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) $(G_LDFLAGS) \
		-o test test.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(DEBUG_FLAVOR).$(G_LIBFILE) \
		$(PORTS0_LIB) $(G_CLIBS)
	if [ "x$(G_POSTPROCESSOR)" != "x" ] ; then \
		$(G_POSTPROCESSOR) test ; \
	fi

test.$(G_OFILE):	$(SRC_PATH)/test.c $(SRC_PATH)/nexus.h
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) \
		-c $(SRC_PATH)/test.c


test.dl:	build_$(DEBUG_FLAVOR) test.$(G_OFILE)
	$(G_RM) -f test.dl
	$(G_CC) $(MY_CFLAGS) $(G_DEBUG_CFLAGS) $(G_LDFLAGS) \
		-o test.dl test.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(DEBUG_FLAVOR).$(G_LIBFILE) $(G_CLIBS) \
		-e _nx_thd_context_entry -lld


testlite:	build_$(DEBUG_FLAVOR)_lite testlite.$(G_OFILE)
	$(G_RM) -f testlite
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o testlite testlite.$(G_OFILE) \
		-L'.' $(LIBBASE_LITE)_$(DEBUG_FLAVOR).$(G_LIBFILE) \
		$(PORTS0LITE_LIB) $(G_CLIBS_LITE)

testlite.$(G_OFILE):	$(SRC_PATH)/testlite.c $(SRC_PATH)/nexus.h
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_DEBUG_CFLAGS_LITE) \
		-c $(SRC_PATH)/testlite.c


testliteo:	build_$(OPT_FLAVOR)_lite testliteo.$(G_OFILE)
	$(G_RM) -f testliteo
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_OPT_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o testliteo testliteo.$(G_OFILE) \
		-L'.' $(LIBBASE_LITE)_$(OPT_FLAVOR).$(G_LIBFILE) \
		$(PORTS0LITE_LIB) $(G_CLIBS_LITE)

testliteo.$(G_OFILE):	$(SRC_PATH)/testliteo.c $(SRC_PATH)/nexus.h
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_OPT_CFLAGS_LITE) \
		-c $(SRC_PATH)/testliteo.c


testlitep:	build_$(PROFILE_FLAVOR)_lite testlitep.$(G_OFILE)
	$(G_RM) -f testlitep
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_PROFILE_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o testlitep testlitep.$(G_OFILE) \
		-L'.' $(LIBBASE_LITE)_$(PROFILE_FLAVOR).$(G_LIBFILE) \
		$(PORTS0LITE_LIB) $(G_CLIBS_LITE)

testlitep.$(G_OFILE):	$(SRC_PATH)/testlitep.c $(SRC_PATH)/nexus.h
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_PROFILE_CFLAGS_LITE) \
		-c $(SRC_PATH)/testlitep.c


testlites:	build_$(SAFE_FLAVOR)_lite testlites.$(G_OFILE)
	$(G_RM) -f testlites
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_SAFE_CFLAGS_LITE) \
		$(G_LDFLAGS_LITE) \
		-o testlites testlites.$(G_OFILE) \
		-L'.' $(LIBBASE_LITE)_$(SAFE_FLAVOR).$(G_LIBFILE) \
		$(PORTS0LITE_LIB) $(G_CLIBS_LITE)

testlites.$(G_OFILE):	$(SRC_PATH)/testlites.c $(SRC_PATH)/nexus.h
	$(G_CC_LITE) -DNEXUS_LITE $(MY_CFLAGS_LITE) $(G_SAFE_CFLAGS_LITE) \
		-c $(SRC_PATH)/testlites.c


testo:	build_$(OPT_FLAVOR) testo.$(G_OFILE)
	$(G_RM) -f testo
	$(G_CC) $(MY_CFLAGS) $(G_OPT_CFLAGS) $(G_LDFLAGS) \
		-o testo testo.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(OPT_FLAVOR).$(G_LIBFILE) \
		$(PORTS0_LIB) $(G_CLIBS)
	if [ "x$(G_POSTPROCESSOR)" != "x" ] ; then \
		$(G_POSTPROCESSOR) testo ; \
	fi

testo.$(G_OFILE):	$(SRC_PATH)/testo.c $(SRC_PATH)/nexus.h
	$(G_CC) $(MY_CFLAGS) $(G_OPT_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"testo\" \
		-c $(SRC_PATH)/testo.c


testp:	build_$(PROFILE_FLAVOR) testp.$(G_OFILE)
	$(G_RM) -f testp
	$(G_CC) $(MY_CFLAGS) $(G_PROFILE_CFLAGS) $(G_LDFLAGS) \
		-o testp testp.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(PROFILE_FLAVOR).$(G_LIBFILE) \
		$(PORTS0_LIB) $(G_CLIBS)
	if [ "x$(G_POSTPROCESSOR)" != "x" ] ; then \
		$(G_POSTPROCESSOR) testp ; \
	fi

testp.$(G_OFILE):	$(SRC_PATH)/testp.c $(SRC_PATH)/nexus.h
	$(G_CC) $(MY_CFLAGS) $(G_PROFILE_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"testp\" \
		-c $(SRC_PATH)/testp.c


tests:	build_$(SAFE_FLAVOR) tests.$(G_OFILE)
	$(G_RM) -f tests
	$(G_CC) $(MY_CFLAGS) $(G_SAFE_CFLAGS) $(G_LDFLAGS) \
		-o tests tests.$(G_OFILE) \
		-L'.' $(LIBBASE)_$(SAFE_FLAVOR).$(G_LIBFILE) \
		$(PORTS0_LIB) $(G_CLIBS)
	if [ "x$(G_POSTPROCESSOR)" != "x" ] ; then \
		$(G_POSTPROCESSOR) tests ; \
	fi

tests.$(G_OFILE):	$(SRC_PATH)/tests.c $(SRC_PATH)/nexus.h
	$(G_CC) $(MY_CFLAGS) $(G_SAFE_CFLAGS) \
		-DTEST_EXECUTABLE_NAME=\"tests\" \
		-c $(SRC_PATH)/tests.c


tc:
	$(G_RM) -f testo.c testp.c tests.c \
		testlite.c testliteo.c testlitep.c testlites.c
	$(G_SYMLINK) test.c testo.c
	$(G_SYMLINK) test.c testp.c
	$(G_SYMLINK) test.c tests.c
	$(G_SYMLINK) test.c testlite.c
	$(G_SYMLINK) test.c testliteo.c
	$(G_SYMLINK) test.c testlitep.c
	$(G_SYMLINK) test.c testlites.c


nexusd: nexusd.c libnexus.a
	$(G_CC) $(G_DEBUG_CFLAGS) -o nexusd nexusd.c -L. -lnexus -lpthreads


hash:	hash.c
	$(G_CC) hash.c -o hash

ibm_entrypt:	$(SRC_PATH)/ibm_entrypt.c
	cc $(SRC_PATH)/ibm_entrypt.c -o ibm_entrypt -lld

ibm_entrypt.exp:	force
	-$(G_RM) -f ibm_entrypt.exp
	@echo "Creating ibm_entrypt.exp"
	echo "_nx_thd_context_entry" > ibm_entrypt.exp

