#
# makefile.ibm.ds.cpp
#
# Sample makefile for an IBM RS/6000, using shared libraries
# and dynamic context loading using st_ibmds and C++
#
# To run on the SP2 high speed switch using TCP, add the 
# following to G_NEXUS_CONFIG:
#     NEXUS_MAP_HOSTNAME NEXUS_MAP_FROM=\"spnode\" NEXUS_MAP_TO=\"swnode\"
# You should change the "spnode" and "swnode" to the appropriate
# base hostnames of your SP nodes.
#
# rcsid = "/net/bcomp/src/master/nexus/makefile.ibm.ds.cpp,v 1.20 1995/08/01 01:35:33 tuecke Exp"
#

G_MAKEFILE=makefile.ibm.ds.cpp
G_MAKEFILE_LNK_SUFFIX=.ibm
G_NEXUS_SPOOF_P0_MAKEFILE=yes
O_DIR=.
SRC_PATH=.
G_OFILE=o
G_LIBFILE=a

G_ARCH=RS6000
G_OTHER_ARCH=AIX AIX_DCE_THREADS DCE_THREADS STARTUP_IBMDS
G_OTHER_ARCH_LITE=AIX
G_CLASS=32BIT_BE
G_PORTS0_TH_MODULE=p0_th_p
G_NEXUS_TH_MODULE=th_p0
G_NEXUS_MD_MODULE=md_unix
G_NEXUS_NL_MODULE=nl_file
G_NEXUS_PROTO_OBJS=$(O_DIR)/pr_tcp.$(G_OFILE)
G_NEXUS_STARTUP_OBJS=$(O_DIR)/st_fork.$(G_OFILE) $(O_DIR)/st_rsh.$(G_OFILE) $(O_DIR)/st_ss.$(G_OFILE) $(O_DIR)/st_ibmds.$(G_OFILE)
G_NEXUS_STATIC_OTHER_OBJS=$(O_DIR)/st_ibmds2.$(G_OFILE) $(O_DIR)/st_ibmds4.$(G_OFILE)
G_NEXUS_STARTUP_OBJS_LITE=$(O_DIR)/st_fork.$(G_OFILE) $(O_DIR)/st_rsh.$(G_OFILE) $(O_DIR)/st_ss.$(G_OFILE)
G_NEXUS_OTHER_OBJS=$(O_DIR)/ibm_cpp_load.$(G_OFILE)
G_NEXUS_DATABASE_OBJS=$(O_DIR)/db_file.$(G_OFILE)
G_CC=/bin/xlc_r
G_CFLAGS=
G_OPT_CFLAGS=-O
G_SAFE_CFLAGS=-O -DNEXUS_DEBUG
G_DEBUG_CFLAGS=-g -DNEXUS_DEBUG
G_PROFILE_CFLAGS=-O -DNEXUS_PROFILE
G_CLIBS=-lld
G_LDFLAGS=-bE:ibm_entrypt.exp
G_POSTPROCESSOR=ibm_entrypt
G_CC_LITE=/bin/xlc
G_CFLAGS_LITE=
G_OPT_CFLAGS_LITE=$(G_OPT_CFLAGS)
G_SAFE_CFLAGS_LITE=$(G_SAFE_CFLAGS)
G_DEBUG_CFLAGS_LITE=$(G_DEBUG_CFLAGS)
G_PROFILE_CFLAGS_LITE=$(G_PROFILE_CFLAGS)
G_CLIBS_LITE=
G_LDFLAGS_LITE=
G_NEXUS_CONFIG=NEXUS_HAS_WAITPID NEXUS_HAS_WAIT_STATUS_MACROS NEXUS_HAS_SIGHOLD NEXUS_THREAD_SAFE_SELECT NEXUS_ALIGN=8 NEXUS_CPP_HACK
G_PORTS0_CONFIG=PORTS0_DEFAULT_STACK_SIZE=1048576 _ALL_SOURCE
G_RM=/bin/rm
G_MAKE=/usr/bin/make
G_MKDIR=/bin/mkdir
G_CP=/bin/cp
G_CHMOD=/bin/chmod
G_FILE_MODE=ugo+r 
G_EXE_FILE_MODE=ugo+x 
G_RANLIB=/usr/bin/true
G_AR=/usr/bin/ar
G_ARFLAGS=qv
G_MKSHR=/bin/xlC_r
G_MV=/bin/mv
G_RSH=/usr/bin/rsh
G_SYMLINK=/bin/ln -s
INSTALL_BASE_DIR=/usr/local/nexus
INSTALL_BIN_DIR=$(INSTALL_BASE_DIR)/bin
INSTALL_LIB_DIR=$(INSTALL_BASE_DIR)/lib
INSTALL_INC_DIR=$(INSTALL_BASE_DIR)/include
G_LISTENER=$(INSTALL_BIN_DIR)/listener
G_FILE_MODE=o-w
G_EXE_FILE_MODE=o-w
INCLUDE_PATH=.
G_MISC_EXE=ibm_makeDynaLoadCntxt
include makefile.bas
